Index: code/trunk/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 2171)
+++ code/trunk/src/orxonox/OrxonoxPrereqs.h	(revision 2261)
@@ -99,4 +99,5 @@
     class QuestDescription;
     class QuestEffect;
+    class QuestEffectBeacon;
     class QuestHint;
     class QuestItem;
@@ -129,4 +130,5 @@
     class DistanceTrigger;
     class EventTrigger;
+    class PlayerTrigger;
 
     class WeaponSystem;
Index: code/trunk/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuest.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddQuest.cc	(revision 2261)
@@ -27,11 +27,19 @@
  */
 
+/**
+    @file AddQuest.cc
+    @brief
+    Implementation of the AddQuest class.
+*/
+
 #include "OrxonoxStableHeaders.h"
 #include "AddQuest.h"
 
 #include <string>
+
 #include "core/CoreIncludes.h"
 #include "util/Exception.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
 #include "Quest.h"
@@ -41,5 +49,8 @@
     CreateFactory(AddQuest);
 
-
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     AddQuest::AddQuest(BaseObject* creator) : ChangeQuestStatus(creator)
     {
@@ -55,21 +66,26 @@
     }
 
+    /**
+    @brief
+        Method for creating a AddQuest object through XML.
+    */
     void AddQuest::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(AddQuest, XMLPort, xmlelement, mode);
-
+        
+        COUT(3) << "New AddQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
     }
 
     /**
     @brief
-        Invokes the effect.
+        Invokes the QuestEffect.
     @param player
-        The player the effect is invoked on.
+        The player the QuestEffect is invoked on.
     @return
-        Returns true if the effect was successfully invoked.
+        Returns true if the QuestEffect was successfully invoked.
     */
-    bool AddQuest::invoke(Player* player)
+    bool AddQuest::invoke(PlayerInfo* player)
     {
-        if(player == NULL)
+        if(player == NULL) //!< Null-pointers are badass.
         {
             COUT(2) << "Input player is NULL." << std::endl;
@@ -77,8 +93,10 @@
         }
 
+        COUT(3) << "AddQuest on player: " << player << " ." << std::endl;
+
         try
         {
             Quest* quest = QuestManager::findQuest(this->getQuestId());
-            if(!quest->start(player))
+            if(quest == NULL || !quest->start(player))
             {
                return false;
@@ -91,4 +109,5 @@
         }
 
+        COUT(3) << "Quest {" << this->getQuestId() << "} successfully added to player." << std::endl;
         return true;
     }
Index: code/trunk/src/orxonox/objects/quest/AddQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuest.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddQuest.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file AddQuest.h
+    @brief
+    Definition of the AddQuest class.
+*/
+
 #ifndef _AddQuest_H__
 #define _AddQuest_H__
@@ -39,9 +45,11 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        Adds a quest, resp. changes the quests status to active.
+        Adds a Quest, resp. changes the quests status to active for the player invoking the Quest.
+        
+        Creating a AddQuest through XML goes as follows:
+        
+        <AddQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be added.
     @author
         Damian 'Mozork' Frick
@@ -53,7 +61,7 @@
             virtual ~AddQuest();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuest object through XML.
 
-            virtual bool invoke(Player* player); //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
     };
Index: code/trunk/src/orxonox/objects/quest/AddQuestHint.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddQuestHint.cc	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file AddQuestHint.cc
+    @brief
+    Implementation of the AddQuestHint class.
+*/
+
 #include "OrxonoxStableHeaders.h"
 #include "AddQuestHint.h"
@@ -33,4 +39,5 @@
 #include "util/Exception.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
 #include "QuestItem.h"
@@ -41,4 +48,8 @@
     CreateFactory(AddQuestHint);
 
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     AddQuestHint::AddQuestHint(BaseObject* creator) : QuestEffect(creator)
     {
@@ -54,4 +65,8 @@
     }
 
+    /**
+    @brief
+        Method for creating a AddQuestHint object through XML.
+    */
     void AddQuestHint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -59,28 +74,39 @@
 
         XMLPortParam(AddQuestHint, "hintId", setHintId, getHintId, xmlelement, mode);
-
+        
+        COUT(3) << "New AddQuestHint, with target QuestHint {" << this->getHintId() << "}, created." << std::endl;
     }
 
-    inline void AddQuestHint::setHintId(const std::string & id)
+    /**
+    @brief
+        Sets the id of the QuestHint to be added to the player the QuestEffect is invoked on.
+    @param id
+        The QuestHint id.
+    @param
+        Returns true if successful.
+    */
+    bool AddQuestHint::setHintId(const std::string & id)
     {
         if(!QuestItem::isId(id))
         {
             COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
-            return;
+            return false;
         }
+        
         this->hintId_ = id;
+        return true;
     }
 
     /**
     @brief
-        Invokes the effect.
+        Invokes the QuestEffect.
     @param player
         The player.
     @return
-        Returns true if the effect was successfully invoked.
+        Returns true if the QuestEffect was successfully invoked.
     */
-    bool AddQuestHint::invoke(Player* player)
+    bool AddQuestHint::invoke(PlayerInfo* player)
     {
-        if(player == NULL)
+        if(player == NULL) //!< NULL-pointers are evil!
         {
             COUT(2) << "The input player is NULL." << std::endl;
@@ -88,8 +114,10 @@
         }
 
+        COUT(3) << "AddQuestHint on player: " << player << " ." << std::endl;
+
         try
         {
             QuestHint* hint = QuestManager::findHint(this->hintId_);
-            if(!hint->activate(player))
+            if(hint == NULL || !hint->setActive(player))
             {
                 return false;
@@ -102,4 +130,5 @@
         }
 
+        COUT(3) << "QuestHint {" << this->getHintId() << "} successfully added to player." << std::endl;
         return true;
 
Index: code/trunk/src/orxonox/objects/quest/AddQuestHint.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddQuestHint.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddQuestHint.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file AddQuestHint.h
+    @brief
+    Definition of the AddQuestHint class.
+*/
+
 #ifndef _AddQuestHint_H__
 #define _AddQuestHint_H__
@@ -38,9 +44,11 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        Adds a QuestHint, resp. Activates the QuestHint.
+        Adds a QuestHint, resp. activates the QuestHint of the given id for the player the QuestEffect is invoked on.
+        
+    Creating a AddQuestHint through XML goes as follows:
+        
+        <AddQuestHint hintId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the QuestHint that should be added.
     @author
         Damian 'Mozork' Frick
@@ -52,14 +60,18 @@
             virtual ~AddQuestHint();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddQuestHint object through XML.
 
-            virtual bool invoke(Player* player); //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
         private:
-            std::string hintId_;
+            std::string hintId_; //!< The id of the QuestHint.
 
+            /**
+            @brief Returns the id of the QuestHint.
+            @return Returns the id of the QuestHint.
+            */
             inline const std::string & getHintId(void) const
                 { return this->hintId_; }
-            void setHintId(const std::string & id);
+            bool setHintId(const std::string & id); //!< Sets the id of the QuestHint.
 
     };
Index: code/trunk/src/orxonox/objects/quest/AddReward.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddReward.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddReward.cc	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file AddReward.cc
+    @brief
+    Implementation of the AddReward class.
+*/
+
 #include "OrxonoxStableHeaders.h"
 #include "AddReward.h"
@@ -32,4 +38,5 @@
 #include "core/CoreIncludes.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
 #include "Rewardable.h"
 
@@ -38,9 +45,11 @@
     CreateFactory(AddReward);
 
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     AddReward::AddReward(BaseObject* creator) : QuestEffect(creator)
     {
         RegisterObject(AddReward);
-
-        this->initialize();
     }
 
@@ -53,4 +62,7 @@
     }
 
+    /**
+        Method for creating a AddReward object through XML.
+    */
     void AddReward::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -58,16 +70,16 @@
 
         XMLPortObject(AddReward, Rewardable, "", addRewardable, getRewardables, xmlelement, mode);
-
+        
+        COUT(3) << "New AddReward, with " << this->rewards_.size() << " Rewardables created." << std::endl;
     }
 
     /**
     @brief
-        Initializes the object. Needs to be called first by every constructor of this class.
+        Returns the Rewardable object at the given index.
+    @param index
+        The index.
+    @return
+        Returns a pointer to the Rewardable object at the given index.
     */
-    void AddReward::initialize(void)
-    {
-        RegisterObject(AddReward);
-    }
-
     const Rewardable* AddReward::getRewardables(unsigned int index) const
     {
@@ -86,11 +98,11 @@
     /**
     @brief
-        Invokes the effect.
+        Invokes the QuestEffect.
     @param player
         The player.
     @return
-        Returns true if the effect was invoked successfully.
+        Returns true if the QuestEffect was invoked successfully.
     */
-    bool AddReward::invoke(Player* player)
+    bool AddReward::invoke(PlayerInfo* player)
     {
         bool check = true;
Index: code/trunk/src/orxonox/objects/quest/AddReward.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/AddReward.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/AddReward.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file AddReward.h
+    @brief
+    Definition of the AddReward class.
+*/
+
 #ifndef _AddReward_H__
 #define _AddReward_H__
@@ -39,9 +45,15 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        Adds a list of rewards to a player.
+        Adds a list of Rewardables to a player.
+        
+        Creating a AddReward through XML goes as follows:
+        
+        <AddReward>
+            <Rewardable /> //A list of Rewardable objects to be rewarded the player, see the specific Rewardables for their respective XML representations.
+            ...
+            <Rewardable />
+        </AddReward>
     @author
         Damian 'Mozork' Frick
@@ -53,16 +65,18 @@
             virtual ~AddReward();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a AddReward object through XML.
 
-            virtual bool invoke(Player* player); //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
         private:
-            std::list<Rewardable*> rewards_;
+            std::list<Rewardable*> rewards_; //!< A list of Rewardables to be added to the player invoking the QuestEffect.
 
-            void initialize(void); //!< Initializes the object.
-
+            /**
+            @brief Add a Rewardable object to the list of objects to be awarded to the player invoking the QuestEffect.
+            @param reward Pointer to the Rewardable to be added.
+            */
             inline void addRewardable(Rewardable* reward)
                 { this->rewards_.push_back(reward); }
-            const Rewardable* getRewardables(unsigned int index) const;
+            const Rewardable* getRewardables(unsigned int index) const; //!< Returns the Rewardable object at the given index.
 
     };
Index: code/trunk/src/orxonox/objects/quest/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/objects/quest/CMakeLists.txt	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/CMakeLists.txt	(revision 2261)
@@ -11,4 +11,5 @@
   QuestDescription.cc
   QuestEffect.cc
+  QuestEffectBeacon.cc
   QuestHint.cc
   QuestItem.cc
Index: code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.cc	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file ChangeQuestStatus.cc
+    @brief
+    Implementation of the ChangeQuestStatus class.
+*/
+
 #include "OrxonoxStableHeaders.h"
 #include "ChangeQuestStatus.h"
@@ -36,4 +42,8 @@
 namespace orxonox {
 
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     ChangeQuestStatus::ChangeQuestStatus(BaseObject* creator) : QuestEffect(creator)
     {
@@ -49,14 +59,8 @@
     }
 
-    void ChangeQuestStatus::setQuestId(const std::string & id)
-    {
-        if(!QuestItem::isId(id))
-        {
-            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
-            return;
-        }
-        this->questId_ = id;
-    }
-
+    /**
+    @brief
+        Method for creating a ChangeQuestStatus object through XML.
+    */
     void ChangeQuestStatus::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
@@ -66,3 +70,23 @@
     }
 
+    /**
+    @brief
+        Sets the id of the Quest the Questffect changes the status of.
+    @param id
+        The id of the Quest.
+    @return
+        Returns true if successful.
+    */
+    bool ChangeQuestStatus::setQuestId(const std::string & id)
+    {
+        if(!QuestItem::isId(id))
+        {
+            COUT(2) << "Invalid id. QuestItem id {" << id << "} could not be set." << std::endl;
+            return false;
+        }
+        
+        this->questId_ = id;
+        return true;
+    }
+
 }
Index: code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/ChangeQuestStatus.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file ChangeQuestStatus.h
+    @brief
+    Definition of the ChangeQuestStatus class.
+*/
+
 #ifndef _ChangeQuestStatus_H__
 #define _ChangeQuestStatus_H__
@@ -39,9 +45,7 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        An effect which changes a quests status.
+        A QuestEffect which changes the status of a specified Quest for the player invoking the QuestEffect.
     @author
         Damian 'Mozork' Frick
@@ -53,16 +57,20 @@
             virtual ~ChangeQuestStatus();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a ChangeQuestStatus object through XML.
 
-            virtual bool invoke(Player* player) = 0; //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player) = 0; //!< Invokes the QuestEffect.
 
         protected:
-            inline const std::string & getQuestId(void) const //!< Returns the quest id.
+            /**
+                @brief Returns the id of the Quest.
+                @return Returns the id of the Quest.
+            */
+            inline const std::string & getQuestId(void) const
                 { return this->questId_; }
 
-            std::string questId_; //!< The id of the quest the status should be changed of.
-
         private:
-            void setQuestId(const std::string & id);
+            std::string questId_; //!< The id of the Quest the status should be changed of.
+            
+            bool setQuestId(const std::string & id); //!< Sets the id of the Quest.
 
     };
Index: code/trunk/src/orxonox/objects/quest/CompleteQuest.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/CompleteQuest.cc	(revision 2261)
@@ -26,4 +26,10 @@
  *
  */
+ 
+/**
+    @file CompleteQuest.cc
+    @brief
+    Implementation of the CompleteQuest class.
+*/
 
 #include "OrxonoxStableHeaders.h"
@@ -33,4 +39,5 @@
 #include "util/Exception.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
 #include "Quest.h"
@@ -40,4 +47,8 @@
     CreateFactory(CompleteQuest);
 
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     CompleteQuest::CompleteQuest(BaseObject* creator) : ChangeQuestStatus(creator)
     {
@@ -53,20 +64,26 @@
     }
 
+    /**
+    @brief
+        Method for creating a CompleteQuest object through XML.
+    */
     void CompleteQuest::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(CompleteQuest, XMLPort, xmlelement, mode);
+        
+        COUT(3) << "New CompleteQuest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
     }
 
     /**
     @brief
-        Invokes the effect.
+        Invokes the QuestEffect.
     @param player
-        The player the effect is invoked on.
+        The player the QuestEffect is invoked on.
     @return
-        Returns true if the effect was invoked successfully.
+        Returns true if the QuestEffect was invoked successfully.
     */
-    bool CompleteQuest::invoke(Player* player)
+    bool CompleteQuest::invoke(PlayerInfo* player)
     {
-        if(player == NULL)
+        if(player == NULL) //!< You know, what we think of NULL-pointers...
         {
             COUT(2) << "Input player is NULL." << std::endl;
@@ -74,8 +91,12 @@
         }
 
+        COUT(3) << "CompleteQuest on player: " << player << " ." << std::endl;
+
+        Quest* quest;
+
         try
         {
-            Quest* quest = QuestManager::findQuest(this->getQuestId());
-            if(!quest->complete(player))
+            quest = QuestManager::findQuest(this->getQuestId());
+            if(quest == NULL || !quest->complete(player))
             {
                return false;
@@ -88,4 +109,5 @@
         }
 
+        COUT(3) << "Quest {" << quest->getId() << "} successfully completed by player: " << player << " ." << std::endl;
         return true;
     }
Index: code/trunk/src/orxonox/objects/quest/CompleteQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/CompleteQuest.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/CompleteQuest.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file CompleteQuest.h
+    @brief
+    Definition of the CompleteQuest class.
+*/
+
 #ifndef _CompleteQuest_H__
 #define _CompleteQuest_H__
@@ -39,9 +45,11 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        Completes a quest.
+        Completes a Quest (with a specified id) for the player invoking the QuestEffect.
+        
+        Creating a CompleteQuest through XML goes as follows:
+        
+        <CompleteQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be completed.
     @author
         Damian 'Mozork' Frick
@@ -53,7 +61,7 @@
             virtual ~CompleteQuest();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a CompleteQuest object through XML.
 
-            virtual bool invoke(Player* player); //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
     };
Index: code/trunk/src/orxonox/objects/quest/FailQuest.cc
===================================================================
--- code/trunk/src/orxonox/objects/quest/FailQuest.cc	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/FailQuest.cc	(revision 2261)
@@ -26,4 +26,10 @@
  *
  */
+ 
+/**
+    @file FailQuest.cc
+    @brief
+    Implementation of the FailQuest class.
+*/
 
 #include "OrxonoxStableHeaders.h"
@@ -33,4 +39,5 @@
 #include "util/Exception.h"
 
+#include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
 #include "Quest.h"
@@ -40,4 +47,8 @@
     CreateFactory(FailQuest);
 
+    /**
+    @brief
+        Constructor. Registers the object.
+    */
     FailQuest::FailQuest(BaseObject* creator) : ChangeQuestStatus(creator)
     {
@@ -53,20 +64,26 @@
     }
 
+    /**
+    @brief
+        Method for creating a FailQuest object through XML.
+    */
     void FailQuest::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
         SUPER(FailQuest, XMLPort, xmlelement, mode);
+        
+        COUT(3) << "New FailQUest, with target Quest {" << this->getQuestId() << "}, created." << std::endl;
     }
 
     /**
     @brief
-        Invokes the effect.
+        Invokes the QuestEffect.
     @param player
-        The player the effect is invoked on.
+        The player the QuestEffect is invoked on.
     @return
-        Returns true if the effect was invoked successfully.
+        Returns true if the QuestEffect was invoked successfully.
     */
-    bool FailQuest::invoke(Player* player)
+    bool FailQuest::invoke(PlayerInfo* player)
     {
-        if(player == NULL)
+        if(player == NULL) //!< We don't know what to do with no player.
         {
             COUT(2) << "Input player is NULL." << std::endl;
@@ -74,8 +91,11 @@
         }
 
+        COUT(3) << "FailQuest on player: " << player << " ." << std::endl;
+
+        Quest* quest;
         try
         {
-            Quest* quest = QuestManager::findQuest(this->getQuestId());
-            if(!quest->fail(player))
+            quest = QuestManager::findQuest(this->getQuestId());
+            if(quest == NULL || !quest->fail(player))
             {
                return false;
@@ -87,5 +107,6 @@
             return false;
         }
-
+        
+        COUT(3) << "Quest {" << quest->getId() << "} failed by player: " << player << " ." << std::endl;
         return true;
     }
Index: code/trunk/src/orxonox/objects/quest/FailQuest.h
===================================================================
--- code/trunk/src/orxonox/objects/quest/FailQuest.h	(revision 2171)
+++ code/trunk/src/orxonox/objects/quest/FailQuest.h	(revision 2261)
@@ -27,4 +27,10 @@
  */
 
+/**
+    @file FailQuest.h
+    @brief
+    Definition of the FailQuest class.
+*/
+
 #ifndef _FailQuest_H__
 #define _FailQuest_H__
@@ -39,9 +45,11 @@
 namespace orxonox {
 
-    class Player; //Forward declaration, remove when fully integrated into the objecthirarchy.
-
     /**
     @brief
-        Fails a quest.
+        Fails a quest (with a specified id) for the player invoking the QuestEffect.
+        
+        Creating a FailQuest through XML goes as follows:
+        
+        <FailQuest questId="id" />  //Where id is a GUID, see http://en.wikipedia.org/wiki/Globally_Unique_Identifier#Basic_structure for more information, and identifies the Quest that should be failed.
     @author
         Damian 'Mozork' Frick
@@ -53,7 +61,7 @@
             virtual ~FailQuest();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a FailQuest object through XML.
 
-            virtual bool invoke(Player* player); //!< Invokes the effect.
+            virtual bool invoke(PlayerInfo* player); //!< Invokes the QuestEffect.
 
     };
